# -*- coding: shift_jis -*-
# --------------------------------------------------------------------
# Weld and Divide Vertices from Files Ver.1.0 Written by Kyotaro
# ====================================================================
# Einglish Description:
# ---------------------
# This script imports Wavefront OBJ file, weld identical vertices, 
# and export again.
# Moreover, this script imports files of both before and after welding,
# and divide polygons keep position of verticies of after welding.
#
# Japanese Description:
# ---------------------
# ̃XNvǵAWavefront OBJ`̃t@Cǂݍ݁A
# ʒuɂ镡̒_Zďo͂܂B
# ܂A_ZÕt@CƗZ̃t@Cǂݍ݁A
# Z̒_ʒuێ܂܍ĕs܂B
######################################################################

import poser
import os
from Numeric import *
from datetime import *

debugMode = 0		# 1: Output few massage. 2: Output full massage.
enco = ""
importFILE1 = ""
importFILE2 = ""
exportFILE = ""
originalAct = ""
weldAct = ""
divideAct = ""

#-----------------------------------------------------------------------------
# Setting language and dialog massage
#
# msgString List - 0. English 1. French 2. German 3. Japanese
# Now, French and German are unavailable.
#-----------------------------------------------------------------------------

msgString = []
msgString.append( ["Weld and Divide", u"", u"", u"_Zĕ"])	#0 Title
msgString.append( ["Select Menu", u"", u"", u"I"])	#1 Massage
msgString.append( ["Weld", u"", u"", u"_Z"])	#2 Menu list 1
msgString.append( ["Divide", u"", u"", u"ĕ"])	#3 Menu list 2
msgString.append( ["Choose Original OBJ", u"", u"", u"ZÕWIgI"])	#4 Import Title
msgString.append( ["Choose Weld OBJ", u"", u"", u"Zς̃WIgI"])	#5 Import Title
msgString.append( ["NOT Wavefront OBJ file", u"", u"", u"t@C`܂B"])	#6 Error message of import
msgString.append( ["Import failed.\nPlease check your file", u"", u"", u"ǍɎs܂B\nt@CmFĂB"])	#7 Error message of import
msgString.append( ["Error:\nVertices is not match.", u"", u"", u"G[F\n_v܂"])	#8 Error message of divide
msgString.append( [" succeeded.\nDou you want to Export this object?", u"", u"", u"ɐ܂B\nWIgo܂H"])	#9 ask export
msgString.append( ["Save to Wavefront OBJ", u"", u"", u"WIgۑ"])	#10 Export Title

def poserLanguage():
	global enco
	if (os.name == "posix"):
		enco = "utf_8"
	else:
		enco = "shift-jis"
	l = poser.Language()
	if l == poser.kLanguageCodeUSENGLISH:
		return 0
#	elif l == poser.kLanguageCodeFRENCH:
#		return 1
#	elif l == poser.kLanguageCodeGERMAN:
#		return 2
	elif l == poser.kLanguageCodeJAPANESE:
		return 3
	else:
		return 0

def msgStr(msgNo):
	return msgString[msgNo][lang].encode(enco) 

#-----------------------------------------------------------------------------
# Import and Export
#-----------------------------------------------------------------------------

def importOBJFile(str):
	imoptions = imex.ImportOptions("OBJ", None)
	imoptions[poser.kImOptCodeCENTERED] = 0
	imoptions[poser.kImOptCodePLACEONFLOOR] = 0
	imoptions[poser.kImOptCodePERCENTFIGSIZE] = -1
	imoptions[poser.kImOptCodeOFFSETX] = 0.0
	imoptions[poser.kImOptCodeOFFSETY] = 0.0
	imoptions[poser.kImOptCodeOFFSETZ] = 0.0 
	imoptions[poser.kImOptCodeWELDIDENTICALVERTS] = 0
	imoptions[poser.kImOptCodeMAKEPOLYNORMSCONSISTENT] = 0
	imoptions[poser.kImOptCodeFLIPNORMS] = 0
	imoptions[poser.kImOptCodeFLIPUTEXTCOORDS] = 0
	imoptions[poser.kImOptCodeFLIPVTEXTCOORDS] = 0
	try:
		imex.Import("OBJ", None, str, imoptions)
		imoptions[poser.kImOptCodePERCENTFIGSIZE] = 100.0
		return 1
	except:
		return 0

def exportOBJFile(str):
	exoptions = imex.ExportOptions("OBJ", None)
	exoptions[poser.kExOptCodeMULTIFRAME] = 0
	exoptions[poser.kExOptCodeFIRSTFRAME] = 0
	exoptions[poser.kExOptCodeLASTFRAME] = 29
	exoptions[poser.kExOptCodeUSEINTERNALNAMES] = 0
	exoptions[poser.kExOptCodeFIGNAMESINGROUPS] = 0
	exoptions[poser.kExOptCodeBODYPARTNAMESINPOLYGROUPS] = 0
	exoptions[poser.kExOptCodeEXISTINGGROUPSINPOLYGROUPS] = 1
	exoptions[poser.kExOptCodeWELDSEAMS] = 0
	exoptions[poser.kExOptCodeASMORPHTARGET] = 0
	try:
		imex.Export("OBJ", None, str, exoptions)
		return 1
	except:
		return 0

#-----------------------------------------------------------------------------
# Weld vertices
#-----------------------------------------------------------------------------

def functionWeld():
	try:
		geo1 = originalAct.Geometry()
	except:
		print "Error: No Geometry" #
	if (geo1):
		start = datetime.now()

		pList = geo1.Polygons()					# Get polygon list from geometry.
		sList = geo1.Sets()						# Get sets list from geometry.

		vList = []
		for v in geo1.Vertices():
			vList.append([v.X(), v.Y(), v.Z()])	# Create vertices list from geometry.
		if debugMode >= 1:
			print "Vertices: ", len(vList) #

		repList = [0]							# Create repetition list of vertices.
		for i, vv in enumerate(vList[1:]):
			try:
				temp = vList[:i+1].index(vv) + 1
			except:
				temp = 0
			repList.append(temp)
		if debugMode >= 1:
			print "Original: ", repList.count(0) #
		if debugMode >= 2:
			print "repetition list : length ", len(repList), "\n", repList #
			print "Sets before tran: ", len(sList), "\n", sList #

		transTable = repList.count(0) * [0]		# Create translation table.
		j = 0
		for i, val in enumerate(repList):
			if val == 0:
				repList[i] = i + 1
				transTable[j] = i
				j += 1
			else:
				for k, s in enumerate(sList):
					if s == i:
						sList[k] = val - 1
		if debugMode >= 2:
			print "Sets after tran1: ", len(sList), "\n", sList #
			print "transTable      : ", len(transTable), "\n", transTable #

		newSets = zeros(len(sList), Int)			# Translate Sets by translation table.
		for i, s in enumerate(sList):
			newSets[i] = transTable.index(s)
		if debugMode >= 2:
			print "Sets after tran2: ", len(newSets), "\n", newSets #

		newPolygons = zeros((len(pList),2), Int)	# Create polygon array from polygon list
		for i, p in enumerate(pList):
			newPolygons[i,0] = p.Start()
			newPolygons[i,1] = p.NumVertices()
		if debugMode >= 2:
			print "newPolygons: length", len(newPolygons), "\n", newPolygons #

		newVertices = zeros((len(transTable),3), Float)	# Create vertices array of necessary vertices.
		for i, t in enumerate(transTable):
			newVertices[i,0] = vList[t][0]
			newVertices[i,1] = vList[t][1]
			newVertices[i,2] = vList[t][2]
		if debugMode >= 2:
			print "newVertices :\n", newVertices #
		if debugMode >= 1:
			print "***** time: ", datetime.now() - start, "*****" #

		if ((sum(max(newPolygons)) <= len(newSets)) & (max(newSets) < len(newVertices))):
			newGeo = poser.NewGeometry()
			newGeo.AddGeneralMesh(newPolygons, newSets, newVertices)
			weldAct = scene.CreatePropFromGeom(newGeo, "Weld_" + originalAct.InternalName())
			matList = weldAct.Materials()
			for mat in matList:
				mat.SetAmbientColor(0.0, 0.0, 0.0)
				mat.SetDiffuseColor(1.0, 1.0, 1.0)
				mat.SetSpecularColor(0.2, 0.2, 0.2)
				mat.SetNs(20.0)
			originalAct.Delete()
			scene.SelectActor(weldAct)
			return 1
		else:
			return 0

#-----------------------------------------------------------------------------
# Divide polygons
#-----------------------------------------------------------------------------

def functionDivide():
	try:
		geo1 = originalAct.Geometry()
		geo2 = weldAct.Geometry()
	except:
		print "Error: No Geometry" #
	if (geo1 and geo2):
		start = datetime.now()

		vList1 = []
		for v in geo1.Vertices():
			vList1.append([v.X(), v.Y(), v.Z()])	# Get vertices list from geometry1.
		if debugMode >= 1:
			print "Vertices1: ", len(vList1) #
		vList2 = geo2.Vertices()					# Get vertices list from geometry2.
		if debugMode >= 1:
			print "Vertices2: ", len(vList2) #

		repList = [0]							# Create repetition list of vertices.
		for i, vv in enumerate(vList1[1:]):
			try:
				temp = vList1[:i+1].index(vv) + 1
			except:
				temp = 0
			repList.append(temp)
		if debugMode >= 1:
			print "Original : ", repList.count(0) #
		if debugMode >= 2:
			print "repetition list: length ", len(repList), "\n", repList #

		if (repList.count(0) == geo2.NumVertices()):
			j = 0
			for i, r in enumerate(repList):
				if r == 0:
					geo1.Vertex(i).SetX(vList2[j].X())
					geo1.Vertex(i).SetY(vList2[j].Y())
					geo1.Vertex(i).SetZ(vList2[j].Z())
					j += 1
				else:
					geo1.Vertex(i).SetX(geo1.Vertex(r-1).X())
					geo1.Vertex(i).SetY(geo1.Vertex(r-1).Y())
					geo1.Vertex(i).SetZ(geo1.Vertex(r-1).Z())
			if debugMode >= 2:
				print "newVertices :\n", vList1 #
			if debugMode >= 1:
				print "***** time: ", datetime.now() - start, "*****" #

			divideAct = scene.CreatePropFromGeom(geo1, "Divide_" + originalAct.InternalName())
			matList = divideAct.Materials()
			for mat in matList:
				mat.SetAmbientColor(0.0, 0.0, 0.0)
				mat.SetDiffuseColor(1.0, 1.0, 1.0)
				mat.SetSpecularColor(0.2, 0.2, 0.2)
				mat.SetNs(20.0)
			scene.SelectActor(divideAct)
			originalAct.Delete()
			weldAct.Delete()
			return 1
		else:
			poser.DialogSimple.MessageBox(msgStr(8))
			return 0

#-----------------------------------------------------------------------------
# Main
#-----------------------------------------------------------------------------

scene = poser.Scene()
imex = scene.ImExporter()
lang = poserLanguage()
flgSuccess = 0

if debugMode >= 1:
	print "****** Run script ******"
	print "* Poser Version: ", poser.AppVersion()
	print "* Language: ", poser.Language(), ",  Massage lists: ", lang

menuList = [msgStr(2), msgStr(3)]
selectMenu = poser.DialogSimple.AskMenu(msgStr(0), msgStr(1), menuList)
if selectMenu == menuList[0]:
	importFILE1 = poser.DialogFileChooser(poser.kDialogFileChooserOpen, None, msgStr(4), os.path.join(os.path.dirname(poser.AppLocation()), "*.obj"))
	if (importFILE1.Show()):
		if debugMode >= 1:
			print "Weld--- File path: ", importFILE1.Path() #
		if ((importFILE1.Path()[-4:]==".obj") | (importFILE1.Path()[-4:]==".OBJ")):
			if (importOBJFile(importFILE1.Path())):
				originalAct = scene.CurrentActor()
				if debugMode >= 1:
					print "Weld--- Original Actor Name: ", originalAct.Name() #
					print "***** Caliculate weld vertices ***** " #
				flgSuccess = functionWeld()
			else:
				poser.DialogSimple.MessageBox(msgStr(7))
		else:
			poser.DialogSimple.MessageBox(msgStr(6))
	else:
		if debugMode >= 1:
			print "Weld--- file selection is canceled" #

elif selectMenu == menuList[1]:
	importFILE1 = poser.DialogFileChooser(poser.kDialogFileChooserOpen, None, msgStr(4), os.path.join(os.path.dirname(poser.AppLocation()), "*.obj"))
	importFILE2 = poser.DialogFileChooser(poser.kDialogFileChooserOpen, None, msgStr(5), os.path.join(os.path.dirname(poser.AppLocation()), "*.obj"))
	if (importFILE1.Show()):
		if debugMode >= 1:
			print "Divide--- File path1: ", importFILE1.Path() #
		if ((importFILE1.Path()[-4:]==".obj") | (importFILE1.Path()[-4:]==".OBJ")):
			if (importOBJFile(importFILE1.Path())):
				originalAct = scene.CurrentActor()
			else:
				poser.DialogSimple.MessageBox(msgStr(7))
		else:
			poser.DialogSimple.MessageBox(msgStr(6))
	else:
		if debugMode >= 1:
			print "Divide--- 1st file selection is canceled" #
	if (originalAct and importFILE2.Show()):
		if debugMode >= 1:
			print "Divide--- File path2: ", importFILE2.Path() #
		if ((importFILE2.Path()[-4:]==".obj") | (importFILE2.Path()[-4:]==".OBJ")):
			if (importOBJFile(importFILE2.Path())):
				weldAct = scene.CurrentActor()
				if debugMode >= 1:
					print "Divide--- Original OBJ: ", originalAct.Name() #
					print "Divide--- Welded OBJ  : ", weldAct.Name() #
					print "***** Caliculate divide polygons ***** " #
				flgSuccess = functionDivide()
			else:
				poser.DialogSimple.MessageBox(msgStr(7))
				originalAct.Delete()
		else:
			poser.DialogSimple.MessageBox(msgStr(6))
			originalAct.Delete()
	else:
		if debugMode >= 1:
			print "Divide--- 2nd file selection is canceled" #
		originalAct.Delete()
else:
	if debugMode >= 1:
		print "--- Menu selection is canceled"

if (flgSuccess):
	if(poser.DialogSimple.YesNo(selectMenu + msgStr(9))):
		exportFILE = poser.DialogFileChooser(poser.kDialogFileChooserSave, None, msgStr(10), os.path.join(os.path.dirname(poser.AppLocation()), "*.obj"))
		if (exportFILE.Show()):
			for ac in scene.Actors():
				ac.SetOnOff(0)
			for fig in scene.Figures():
				fig.SetOnOff(0)
			scene.CurrentActor().SetOnOff(1)
			if((exportFILE.Path()[-4:]!=".obj") and (exportFILE.Path()[-4:]!=".OBJ")):
				exportOBJFile(exportFILE.Path() + ".obj")
				if debugMode >= 1:
					print "Export--- File path: ", exportFILE.Path() + ".obj" #
			else:
				exportOBJFile(exportFILE.Path())
				if debugMode >= 1:
					print "Export--- File path: ", exportFILE.Path() #

if debugMode >= 1:
	print "****** All process is ended. ******" #

#-----------------------------------------------------------------------------
